%define  patch_name kernel-fix-net

Name: %patch_name
Version: 2005.08.14
Release: alt1.M30.5

Summary: %patch_name kernel patch - Linux network layer fixes
License: GPL
Group: Development/Kernel
Packager: Kernel Maintainers Team <kernel@packages.altlinux.org>

%source  0	2.4_00_irlan-makefile-fix.patch				2.4
%source  1	2.4_01_module_license.patch				2.4
%source  2	2.4_02_8021q-proc-update.patch				2.4
%source  3	2.4_03_sk_rmem_alloc-assertion-failure-1.patch		2.4
%source  4	2.4_04_ipvs-unchecked-strcpy-1.diff.patch		2.4
%source  5	2.4_05_rtnetlink-off-by-one-1.patch			2.4
%source  6	2.4_06_stretch-ack-kills-performance-1.patch		2.4
%source  7	2.4_07_ip_vs_conn_tab-race-1.patch			2.4
%source  8	2.4_08_ipv4-peers-negative-timer-1.patch		2.4
%source  9	2.4_09_ipv6-route-events-with-wrong-netlink-pid-1.patch	2.4
%source 10	2.4_10_nat-fix-memory-corruption-1.patch		2.4
%source 11	2.4_11_nat-module-load-race-1.patch			2.4
%source 12	2.4_12_netfilter-tcp-unclean-1.diff.patch		2.4
%source 13	2.4_13_32bit-sys_recvmsg-corruption-1.patch		2.4
%source 14	2.4_14_af_unix-fix-siocinq-for-stream-1.patch		2.4
%source 15	2.4_15_bogus-mc_list-deletion-1.patch			2.4
%source 16	2.4_16_ipconfig-use-memmove-not-strcpy-1.patch		2.4
%source 17	2.4_17_kfree_skb-missing-memory-barrier-1.patch		2.4
%source 18	2.4_18_net-oops-base_reachable_time-zero-1.patch	2.4
%source 19	2.4_19_net-put-barriers-around-dst-refcnt-1.patch	2.4
%source 20	2.4_20_netlink-fix-nlmsg_goodsize-calculation-1.patch	2.4
%source 21	2.4_21_netlink-multicast-bind-race-1.patch		2.4
%source 22	2.4_22_netlink_remove-unhash-leaks-sockets-1.patch	2.4
%source 23	2.4_23_pkt_sched-netem-leaks-memory-1.patch		2.4
%source 24	2.4_24_rtnetlink-set-multi-flags-1.patch		2.4
%source 25	2.4_25_tcp-bic-reset-cwnd-on-loss-1.patch		2.4
%source 26	2.4_26_wireless-data-leak-1.patch			2.4
%source 27	2.4_27_netlink-socket-hashing-bugs-2.patch		2.4
%source 28	2.4_28_ip_vs_ftp-persistence-breaks-connections-1.patch	2.4
%source 29	2.4_29_ipvs-invalidate-persistent-templates-1.patch	2.4
%source 30	2.4_30_mcast-exclude-typos-1.patch			2.4
%source 31	2.4_31_netfilter-gcc-3.4.3-build-1.patch		2.4
%source 32	2.4_32_tcp_clamp_window-fix-1.patch			2.4
%source 33	2.4_33_ip_vs_conn_expire_now-fix_refcnt-dec-1.patch	2.4
%source 34	2.4_34_mcast-filter-1.patch				2.4

%source 2601	2.6_01_netlink-socket-hashing.patch			2.6
%source 2603	2.6_03_netfilter-conntrack-fix-fix.patch		2.6
%source 2604	2.6_04_early-vlan-fix.patch				2.6
%source 2605	2.6_05_ipsec-array-overflow.patch			2.6
%source 2606	2.6_06_netfilter-NAT-memory-corruption.patch		2.6
%source 2607	2.6_07_netfilter-deadlock-ip6_queue.patch		2.6
%source 2608	2.6_08_netfilter-ip_conntrack_untracked-refcount.patch	2.6
%source 2609	2.6_09_skb-signedness-fix.patch				2.6
%source 2610	2.6_10_fix-dst-leak-in-icmp_push_reply.patch		2.6
%source 2611	2.6_11_ipsec-socket-policy-use-cap.patch		2.6
%source 2612	2.6_12_ipv6-skb-leak.patch				2.6
%source 2613	2.6_13_ip_conntrack-tcp-accept-syn+push-like-syn.patch	2.6
%source 2614	2.6_14_ipv4-fragmentation-csum-handling.patch		2.6
%source 2615	2.6_15_ipv6-fix-per-socket-mcast-filtering.patch	2.6
%source 2616	2.6_16_br-fix-race-on-bridge-del-if.patch		2.6
%source 2617	2.6_17_br-recompute-features.patch			2.6
%source 2618	2.6_18_gre-hw-csum-modification.patch			2.6
%source 2619	2.6_19_vlan-checksumming.patch				2.6
%source 2620	2.6_20_ebt_ip-fragments.patch				2.6
%source 2621	2.6_21_get_wireless_stats-sysfs.patch			2.6
%source 2622	2.6_22_skb_reserve-signed-arg.patch			2.6
%source 2623	2.6_23_netlink-overrun-fix.patch			2.6
%source 2624	2.6_24_netfilter-ip_queue-nlmsg_len.patch		2.6
%source 2625	2.6_25_SO_BINDTODEVICE-name-null-terminated.patch	2.6


BuildArch: noarch
BuildRequires: kernel-build-tools

%description
Linux network layer fixes

%install
%install_patches

%files
%_usrsrc/*

%changelog
* Fri Jun 30 2006 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1.M30.5
- Added patches for 2.6.12:
  + 2.6_23_netlink-overrun-fix.patch: netlink: fix bug in overrun handling
  + 2.6_24_netfilter-ip_queue-nlmsg_len.patch: netfilter: ip_queue: fix wrong
    skb->len == nlmsg_len assumption
  + 2.6_25_SO_BINDTODEVICE-name-null-terminated.patch: ensure device name
    passed to SO_BINDTODEVICE is NULL terminated

* Wed Feb 08 2006 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1.M30.4
- Added patches for 2.6.12:
  + 2.6_14_ipv4-fragmentation-csum-handling.patch: ipv4: fix reassembly trim
    not clearing CHECKSUM_HW
  + 2.6_15_ipv6-fix-per-socket-mcast-filtering.patch: ipv6: fix per-socket
    multicast filtering in exact-match case
  + 2.6_16_br-fix-race-on-bridge-del-if.patch: br: fix race on bridge del if
  + 2.6_17_br-recompute-features.patch: br: recompute features when adding a
    new device
  + 2.6_18_gre-hw-csum-modification.patch: ip_gre: fix hardware checksum
    modification
  + 2.6_19_vlan-checksumming.patch: vlan: fix hardware rx csum errors
  + 2.6_20_ebt_ip-fragments.patch: ebtables: don't match tcp/udp
    source/destination port for IP fragments
  + 2.6_21_get_wireless_stats-sysfs.patch: fix /sys/class/net/<if>/wireless
    without dev->get_wireless_stats
  + 2.6_22_skb_reserve-signed-arg.patch: make second arg to skb_reserve()
    signed

* Sun Nov 27 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1.M30.3
- Added patches for 2.6.12:
  + 2.6_13_ip_conntrack-tcp-accept-syn+push-like-syn.patch: netfilter:
    ip_conntrack TCP: Accept SYN+PUSH like SYN

* Sun Nov 06 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1.M30.2
- Added patches for 2.4.29:
  - 2.4_03_sk_rmem_alloc-assertion-failure-1.patch: fix sk_rmem_alloc assertion
    failure in af_netlink.c
  - 2.4_04_ipvs-unchecked-strcpy-1.diff.patch: ipvs: replaced several unchecked
    strcpy() with strncpy()
  - 2.4_05_rtnetlink-off-by-one-1.patch: fix off-by-one error in rtnetlink.c
  - 2.4_06_stretch-ack-kills-performance-1.patch: tcp: fix stretch ACK
    performance killer when doing ucopy
  - 2.4_07_ip_vs_conn_tab-race-1.patch: ipvs: close race conditions on
    ip_vs_conn_tab list modification
  - 2.4_08_ipv4-peers-negative-timer-1.patch: fix negative timer loop with lots
    of ipv4 peers
  - 2.4_09_ipv6-route-events-with-wrong-netlink-pid-1.patch: ipv6: fix route
    events reported with wrong netlink PID and seq number
  - 2.4_10_nat-fix-memory-corruption-1.patch: netfilter: fix potential memory
    corruption in NAT code
  - 2.4_11_nat-module-load-race-1.patch: netfilter: handle NAT module load race
  - 2.4_12_netfilter-tcp-unclean-1.diff.patch: netfilter: ignore PSH on SYN/ACK
    in ipt_unclean
  - 2.4_13_32bit-sys_recvmsg-corruption-1.patch: fix possible corruption is
    sys_recvmsg
  - 2.4_14_af_unix-fix-siocinq-for-stream-1.patch: AF_UNIX: Fix SIOCINQ for
    STREAM sockets
  - 2.4_15_bogus-mc_list-deletion-1.patch: netlink: fix bogus mc_list deletion
  - 2.4_16_ipconfig-use-memmove-not-strcpy-1.patch: ipv4: ipconfig should use
    memmove() instead of strcpy()
  - 2.4_17_kfree_skb-missing-memory-barrier-1.patch: add missing memory barrier
    to kfree_skb()
  - 2.4_18_net-oops-base_reachable_time-zero-1.patch: fix kernel oops if
    base_reachable_time is set to 0
  - 2.4_19_net-put-barriers-around-dst-refcnt-1.patch: add barriers for dst
    refcnt
  - 2.4_20_netlink-fix-nlmsg_goodsize-calculation-1.patch: netlink: use
    SKB_MAXORDER to calculate NLMSG_GOODSIZE
  - 2.4_21_netlink-multicast-bind-race-1.patch: netlink: fix multicast
    bind/autobind race
  - 2.4_22_netlink_remove-unhash-leaks-sockets-1.patch: netlink: unhash sockets
    correctly
  - 2.4_23_pkt_sched-netem-leaks-memory-1.patch: sch_netem: fix memory leak
  - 2.4_24_rtnetlink-set-multi-flags-1.patch: set NLM_F_MULTI for neighbour
    rtnetlink messages to userspace
  - 2.4_25_tcp-bic-reset-cwnd-on-loss-1.patch: TCP: fix BIC not binary
    searching correctly
  - 2.4_26_wireless-data-leak-1.patch: fix potential leak of kernel data to
    user space in wireless private handler helper
  - 2.4_27_netlink-socket-hashing-bugs-2.patch: netlink: fix more socket
    hashing bugs
  - 2.4_28_ip_vs_ftp-persistence-breaks-connections-1.patch: ip_vs_ftp breaks
    connections using persistence
  - 2.4_29_ipvs-invalidate-persistent-templates-1.patch: ipvs: really
    invalidate persistent templates
  - 2.4_30_mcast-exclude-typos-1.patch: fix MCAST_EXCLUDE line dupes
  - 2.4_31_netfilter-gcc-3.4.3-build-1.patch: netfilter: fixes gcc 3.4.3
    compilation issue
  - 2.4_32_tcp_clamp_window-fix-1.patch: don't over-clamp window in
    tcp_clamp_window()
  - 2.4_33_ip_vs_conn_expire_now-fix_refcnt-dec-1.patch: ipvs: fix connection
    expiry
  - 2.4_34_mcast-filter-1.patch: ipv6: fix MSFILTER ioctl

* Mon Oct 24 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1.M30.1
- Added:
  + 2.6_10_fix-dst-leak-in-icmp_push_reply.patch: ipv4: fix DST leak in
    icmp_push_reply()
  + 2.6_11_ipsec-socket-policy-use-cap.patch: ipsec: restrict socket policy
    loading to CAP_NET_ADMIN (CAN-2005-2555)
  + 2.6_12_ipv6-skb-leak.patch: ipv6: fix SKB leak in ip6_input_finish()

* Sun Aug 14 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.08.14-alt1
- Added:
  + 2.6_04_early-vlan-fix.patch: fix early vlan adding leads to not functional
    device
  + 2.6_05_ipsec-array-overflow.patch: xfrm: fix possible overflow of
    sock->sk_policy
  + 2.6_06_netfilter-NAT-memory-corruption.patch: fix potential memory
    corruption in NAT code
  + 2.6_07_netfilter-deadlock-ip6_queue.patch: fix deadlock in ip6_queue
  + 2.6_08_netfilter-ip_conntrack_untracked-refcount.patch: wait until all
    references to ip_conntrack_untracked are dropped on unload
  + 2.6_09_skb-signedness-fix.patch: fix signedness issues in net/core/filter.c

* Mon Jul 25 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.07.25-alt1
- Removed:
  - 2.6_00_netfilter-bridge-fix.patch (broken)
- Added:
  + 2.6_03_netfilter-conntrack-fix-fix.patch: revert the nf_reset change
    completely (previous fix was not enough); drop conntrack references
    manually before packets are queued to packet sockets

* Sat Jul 02 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.07.02-alt1
- Updated for kernel 2.6.12.
- Removed obsolete patches:
  - 2.6_00_export-tcp_timer_bug_msg.patch
  - 2.6_01_netrom-locking-fix.patch
  - 2.6_02_proc-net-route-oops.patch
  - 2.6_03_fix-__xfrm_find_acq_byseq.patch
  - 2.6_04_ipsec-deadlock.patch
  - 2.6_05_tcp-bic-fix.patch
  - 2.6_06_ebtables-fix-smp-race.patch
  - 2.6_07_rose-verify-ndigis.patch
  - 2.6_08_bridge-fdb-postfilter.patch
  - 2.6_09_netem-duplication-fix.patch
  - 2.6_10_netfilter-ip_queue-deadlock-fix.patch
- Added:
  + 2.6_00_netfilter-bridge-fix.patch: fix connection tracking on bridges
  + 2.6_01_netlink-socket-hashing.patch: fix socket hashing bugs in netlink

* Mon Jun 13 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.06.13-alt1
- Added patches for 2.6:
  + 2.6_08_bridge-fdb-postfilter.patch: avoid poisoning of the bridge
    forwarding table by frames that have been dropped by filtering
  + 2.6_09_netem-duplication-fix.patch: netem: avoid infinite loop in
    qdisc_run() when using duplication
  + 2.6_10_netfilter-ip_queue-deadlock-fix.patch: fix deadlock with ip_queue
    and tcp local input path

* Fri May 13 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.05.13-alt1
- Added patches for 2.6:
  + 2.6_06_ebtables-fix-smp-race.patch: fix smp race under heavy load
  + 2.6_07_rose-verify-ndigis.patch: verify ndigis in rose_rt_ioctl()

* Tue May 10 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.05.10-alt1
- Added patches for 2.6:
  + 2.6_04_ipsec-deadlock.patch: fix deadlock in IPsec when sending ICMP
    "fragmentation needed" packet
  + 2.6_05_tcp-bic-fix.patch: fix binary search in the BIC congestion control
    algorithm

* Tue Mar 29 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.03.29-alt1
- Added patches for 2.6:
  + 2.6_01_netrom-locking-fix.patch: fix deadlock in NetROM
  + 2.6_02_proc-net-route-oops.patch: fix crash while reading /proc/net/route
  + 2.6_03_fix-__xfrm_find_acq_byseq.patch: fix bug in IPSEC support

* Mon Mar 14 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.03.14-alt1
- Updated for kernel 2.6.11.
- Removed obsolete patches:
  - 2.6_00_008-sock_without_ipv6.patch
  - 2.6_00_009-ipt_ecn_corrupt_chksum.patch
  - 2.6_00_012-conntrack_standalone_proc_removal.patch
  - 2.6_00_013-conntrack_standalone_sysctl.patch
  - 2.6_00_017-conntrack_sctp_sysctl.patch
  - 2.6_00_018-ipt_recent_proc_remove.patch
  - 2.6_00_019-conntrack_tcp_RST_handling.patch
  - 2.6_00_021-sunrpc_check_before_kill.patch
  - 2.6_00_022-sunrpc_xdr_flush_pages.patch
  - 2.6_00_037-sctp_err_lookup_oops.patch
  - 2.6_00_040-sk_forward_alloc_underflow.patch
  - 2.6_00_046-ipv6_sit_lock.patch
  - 2.6_00_047-do_tcp_sendpages_tso_assertion.patch
  - 2.6_00_072-sctp_do_bind_random_port.patch
- Added:
  + 2.6_00_export-tcp_timer_bug_msg.patch: export tcp_timer_bug_msg for modular
    ipv6 build

* Wed Feb 09 2005 Sergey Vlasov <vsu@altlinux.ru> 2005.02.09-alt1
- Added patches from 2.6.10-as3:
  + 2.6_00_008-sock_without_ipv6.patch
  + 2.6_00_009-ipt_ecn_corrupt_chksum.patch
  + 2.6_00_012-conntrack_standalone_proc_removal.patch
  + 2.6_00_013-conntrack_standalone_sysctl.patch
  + 2.6_00_017-conntrack_sctp_sysctl.patch
  + 2.6_00_018-ipt_recent_proc_remove.patch
  + 2.6_00_019-conntrack_tcp_RST_handling.patch
  + 2.6_00_021-sunrpc_check_before_kill.patch
  + 2.6_00_022-sunrpc_xdr_flush_pages.patch
  + 2.6_00_037-sctp_err_lookup_oops.patch
  + 2.6_00_040-sk_forward_alloc_underflow.patch
  + 2.6_00_046-ipv6_sit_lock.patch
  + 2.6_00_047-do_tcp_sendpages_tso_assertion.patch
  + 2.6_00_072-sctp_do_bind_random_port.patch

* Wed Dec 29 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.12.29-alt1
- Updated for kernel 2.6.10.
- Removed obsolete patches:
  - 2.6_50_ip-conntrack-depends-fix.patch

* Thu Oct 28 2004 Anton Farygin <rider@altlinux.ru> 2004.10.28-alt1
- Added for 2.6.9:
    - 2.6_50_ip-conntrack-depends-fix.patch

* Sun Oct 17 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.10.17-alt1
- Updated for kernel 2.4.27.
- Removed obsolete patches:
   - 02_msfilter-error.patch
   - 03_masquerade-ip_rt_put.patch
- Added:
   + 02_8021q-proc-update.patch: updated 8021q (VLAN) /proc support code (fixes
     /proc/net/vlan/config truncation with large number of VLANs; Bug #5296)

* Sun May 09 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.05.09-alt1
- Updated for kernel 2.4.26.
- Removed obsolete patches:
  - 02_ipt_ECN-unclone-fix.patch
  - 03_nat-unused.patch
  - 04_udp-no-EAGAIN.patch
  - 08_igmp-ip_mc_down.patch
  - 09_igmp-init-fix.patch
  - 10_ipv4-tcp_tw_put.patch
  - 11_ipv6-tcp_tw_put.patch
- Added:
  + 02_msfilter-error.patch: fix return value on MCAST_MSFILTER error case
  + 03_masquerade-ip_rt_put.patch: missing ip_rt_put in ipt_MASQUERADE

* Tue Apr 20 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.04.20-alt1
- Removed (moved to kernel-fix-security):
  - 05_igmp-msfilter-check.patch
  - 06_igmp-msfilter-check.patch
  - 07_export-sysctl_optmem_max.patch

* Sat Apr 03 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.04.03-alt1
- Added:
  + 08_igmp-ip_mc_down.patch: do nothing in ip_mc_down() if ip_mc_up() was not
    called previously
  + 09_igmp-init-fix.patch: fix IGMPv3 timer initialization when device not
    'upped'
  + 10_ipv4-tcp_tw_put.patch: use tcp_tw_put on time-wait sockets
  + 11_ipv6-tcp_tw_put.patch: use tcp_tw_put on time-wait sockets (IPv6)

* Thu Mar 18 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.03.18-alt1
- Added:
  + 02_ipt_ECN-unclone-fix.patch: fix ECN target cloned skb problem
  + 03_nat-unused.patch: kill unused structure member
  + 04_udp-no-EAGAIN.patch: do not return -EAGAIN on blocking UDP socket
  + 05_igmp-msfilter-check.patch: verify MSFILTER option length
  + 06_igmp-msfilter-check.patch: check for MSFILTER length overflow
  + 07_export-sysctl_optmem_max.patch: export sysctl_optmem_max to modules

* Mon Feb 23 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.02.23-alt1
- Updated for kernel 2.4.25.
- Removed obsolete patches (merged upstream):
  - 15_sock_queue_rcv_skb-len.patch
  - 16_econet-skb-leak.patch

* Mon Jan 19 2004 Sergey Vlasov <vsu@altlinux.ru> 2004.01.19-alt1
- Updated for kernel 2.4.24.
- Removed obsolete patches (merged upstream):
  - 02_iproute2-build-fix.patch
  - 04_bridge-kfree_skb.patch
  - 05_bridge-checksum-fix.patch
  - 06_ipt_REJECT-OUTPUT-fix.patch
  - 07_igmp-ip_mc_list-deadlock.patch
  - 08_skb-unshare-before-mangling.patch
  - 09_vlan-shared-skb.patch
  - 10_ip_fragment-nfcache.patch
  - 11_ipv6-mcast-typo.patch
  - 12_ipt_REDIRECT-oops.patch
  - 13_destroy_conntrack-locking.patch
  - 14_conntrack-original-dst.patch

* Mon Dec 15 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.12.15-alt1
- Added:
  + 15_sock_queue_rcv_skb-len.patch: do not deref skb->len after it is
    queued to the socket.
  + 16_econet-skb-leak.patch: Do not leak SKBs if ec_queue_packet()
    fails.

* Sun Nov 09 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.11.09-alt1
- Added:
  + 13_destroy_conntrack-locking.patch
  + 14_conntrack-original-dst.patch
- Removed:
  - 03_nat-range-fix.patch (seems to uncover more problems in netfilter which
    are not yet fixed).

* Thu Nov 06 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.11.06-alt1
- Removed 02_kill_igmpv3.patch (replaced with another version which was
  accepted into 2.4.23-pre).
- Added:
  + 02_iproute2-build-fix.patch
  + 03_nat-range-fix.patch
  + 04_bridge-kfree_skb.patch
  + 05_bridge-checksum-fix.patch
  + 06_ipt_REJECT-OUTPUT-fix.patch
  + 07_igmp-ip_mc_list-deadlock.patch
  + 08_skb-unshare-before-mangling.patch
  + 09_vlan-shared-skb.patch
  + 10_ip_fragment-nfcache.patch
  + 11_ipv6-mcast-typo.patch
  + 12_ipt_REDIRECT-oops.patch

* Mon Sep 29 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.09.29-alt1
- added 02_kill_igmpv3.patch: hide IGMPv3 definitions from <linux/in.h> when
  included from userspace (workaround for #3053)

* Tue Sep 16 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.09.16-alt1
- added 01_module_license.patch: add missing MODULE_LICENSE

* Tue Jul 15 2003 Sergey Vlasov <vsu@altlinux.ru> 2003.07.15-alt1
- added:
  + irlan-makefile-fix - avoid duplicate modules

